
/**
 * ^Cg:     Noiz<p>
 * :         <p>
 * 쌠:       Copyright (c) Kenta Cho(ABA."Saba")<p>
 * Ж:       ABA Games<p>
 * @author Kenta Cho(ABA."Saba")
 * @version 1.0
 */
package jp.gr.java_conf.abagames.noiz;

import jp.gr.java_conf.abagames.noiz.curtainmaker.*;
import jp.gr.java_conf.abagames.noiz.texturemaker.*;
import jp.gr.java_conf.abagames.util.*;

public class GameManager implements ITime {

// ported from Palm

private final int CTTYPE_MAX = CurtainMaker.CTTYPE_MAX;
private final int BULLET_MAX = CurtainMaker.BULLET_MAX;
private final int BULLET_NOT_EXIST = CurtainMaker.BULLET_NOT_EXIST;

//GameStatus gameStatus = new GameStatus();
int xp, yp, pxp, pyp;

CurtainMaker[][] ctType = new CurtainMaker[2][CTTYPE_MAX];
int[][] ctTypeQue = new int [2][CTTYPE_MAX];
int[] cttqStatus = new int[2];
int cttqSelect;
LevelStatus levelStatus = new LevelStatus();

PrefData prefData = new PrefData();

Bullet[] bullet = new Bullet[BULLET_MAX];

private void getPrefData() {
  int i, j;
  for ( i=0 ; i<2 ; i++ ) {
    for ( j=0 ; j<CTTYPE_MAX ; j++ ) {
      ctTypeQue[i][j] = prefData.ctTypeQue[i][j];
    }
    cttqStatus[i] = prefData.cttqStatus[i];
  }
  cttqSelect = prefData.cttqSelect;
  levelStatus.level = prefData.level;
  levelStatus.miss = prefData.miss;
  levelStatus.lvlTime = prefData.lvlTime;
}

private void makePrefData() {
  int i, j;
  for ( i=0 ; i<2 ; i++ ) {
    for ( j=0 ; j<CTTYPE_MAX ; j++ ) {
       prefData.ctTypeQue[i][j] = ctTypeQue[i][j];
    }
    prefData.cttqStatus[i] = cttqStatus[i];
  }
  prefData.cttqSelect = cttqSelect;
  prefData.level = levelStatus.level;
  prefData.miss = levelStatus.miss;
  prefData.lvlTime = levelStatus.lvlTime;
}

private void initCurtainType() {
  ctType[0][0] = new AimFire(bullet, 7);
  ctType[0][1] = new VctFire(bullet, 10);
  ctType[0][2] = new ExtendFire(bullet, 10);
  ctType[0][3] = new DiaFire(bullet, 12);
  ctType[0][4] = new AimLaser(bullet, 5);
  ctType[0][5] = new RippleFire(bullet, 14);
  ctType[0][6] = new SrkVctFire(bullet, 10);
  ctType[0][7] = new GoutFire(bullet, 8);
  ctType[0][8] = new PrlFire(bullet, 4);
  ctType[0][9] = new RndRollFire(bullet, 6);
  ctType[0][10] = new SplayFire(bullet, 8);
  ctType[0][11] = new AimVrtFire(bullet, 5);

  ctType[1][0] = new VrtLaser(bullet, 4);
  ctType[1][1] = new RndFire(bullet, 8);
  ctType[1][2] = new Winder(bullet, 10);
  ctType[1][3] = new RdmFire(bullet, 3);
  ctType[1][4] = new BeeWinder(bullet, 8);
  ctType[1][5] = new RollFire(bullet, 10);
  ctType[1][6] = new BoxFire(bullet, 4);
  ctType[1][7] = new BeeFire(bullet, 12);
  ctType[1][8] = new SiegeWinder(bullet, 5);
  ctType[1][9] = new VrtRdmFire(bullet, 5);
  ctType[1][10] = new RdmLaser(bullet, 5);
  ctType[1][11] = new RndVctFire(bullet, 7);
}

private void initCurtainTypeQue() {
  int i, j;
  for ( i=0 ; i<2 ; i++ ) {
    for ( j=0 ; j<CTTYPE_MAX ; j++ ) {
      ctTypeQue[i][j] = j;
    }
  }
  levelStatus.level = 0;
  levelStatus.miss = 0;
  cttqStatus[0] = cttqStatus[1] = 0;
  cttqSelect = 0;
}

private void initGame() {
  levelStatus.level = -1;
  initCurtainType();
  initCurtainTypeQue();
  for ( int i=0 ; i<bullet.length ; i++ ) {
    bullet[i] = new Bullet();
  }
}

private void resetBullets() {
  int i;
  for ( i=0 ; i<BULLET_MAX ; i++ ) {
    bullet[i].point0.mx = BULLET_NOT_EXIST;
  }
}

private int rollCurtainTypeQue(int[] ctq, int status, int rDiv) {
  int i;
  int ctptr = ctq[0];
  if ( status == 0 ) {
    for ( i=0 ; i<CTTYPE_MAX-1 ; i++ ) {
      ctq[i] = ctq[i+1];
    }
    ctq[CTTYPE_MAX-1] = ctptr;
    return 1;
  } else {
    int idx = (CTTYPE_MAX/rDiv)*(rDiv-1);
    for ( i=0 ; i<idx ; i++ ) {
      ctq[i] = ctq[i+1];
    }
    ctq[idx] = ctptr;
    return 0;
  }
}

private final int MIXED_CURTAIN_PRM = 96;
private final int LEVEL_TIME = 80;
private final int LEVEL_TIME_MIN = 50;

private boolean firstLevel = true;

private void showLevel(boolean retry) {
  int color;
  if ( retry ) color = 0x882222;
  else color = 0x228822;
  Letters letters = screen.letters;
  letters.clear();
  letters.addLetter(10+'L'-'A', 8, 70, 4, color);
  letters.addLetter(10+'E'-'A', 16, 70, 4, color);
  letters.addLetter(10+'V'-'A', 24, 70, 4, color);
  letters.addLetter(10+'E'-'A', 32, 70, 4, color);
  letters.addLetter(10+'L'-'A', 40, 70, 4, color);
  int level = levelStatus.level;
  int lx = 52;
  if ( level >= 100 ) {
    letters.addLetter((level/100)%10, lx, 70, 4, color);
    lx += 8;
  }
  if ( level >= 10 ) {
    letters.addLetter((level/10)%10, lx, 70, 4, color);
    lx += 8;
  }
  letters.addLetter(level%10, lx , 70, 4, color);

  if ( retry ) {
    letters.addLetter(10+'R'-'A', 21, 40, 6, color);
    letters.addLetter(10+'E'-'A', 31, 40, 6, color);
    letters.addLetter(10+'T'-'A', 41, 40, 6, color);
    letters.addLetter(10+'R'-'A', 51, 40, 6, color);
    letters.addLetter(10+'Y'-'A', 61, 40, 6, color);
    letters.drawBox(10, 50, 70, 52, color);
    letters.drawBox(10, 28, 70, 30, color);
    letters.drawBox(10, 31, 12, 49, color);
    letters.drawBox(68, 31, 70, 49, color);
  } else if ( firstLevel ) {
    firstLevel = false;
    letters.addLetter(10+'S'-'A', 21, 40, 6, color);
    letters.addLetter(10+'T'-'A', 31, 40, 6, color);
    letters.addLetter(10+'A'-'A', 41, 40, 6, color);
    letters.addLetter(10+'R'-'A', 51, 40, 6, color);
    letters.addLetter(10+'T'-'A', 61, 40, 6, color);
    letters.drawBox(10, 50, 70, 52, color);
    letters.drawBox(10, 28, 70, 30, color);
    letters.drawBox(10, 31, 12, 49, color);
    letters.drawBox(68, 31, 70, 49, color);
  }

  letters.valid();
}

private void gotoNextLevel() {
  int i;
  int lvl;
  int lvlPrm;
  CurtainMaker fstct;
  makePrefData();
  levelStatus.level++;
  CurtainMaker.timer = 0;
  levelStatus.lvlTime = LEVEL_TIME;

  showLevel(false);
  screen.setLevelTexture(levelStatus.level);

  /*levelStatus.curtainNmb = 1;
  levelStatus.curtain[0].curtainMaker = ctType[1][1];
  levelStatus.curtain[0].rank = 4;//ctType[1][1].maxRank;*/

  fstct = ctType[0][ctTypeQue[0][0]];
  cttqStatus[0] = rollCurtainTypeQue(ctTypeQue[0], cttqStatus[0], 2);
  lvl = levelStatus.level;
  levelStatus.curtainNmb = 1;
  if ( lvl <= fstct.maxRank ) {
    levelStatus.curtain[0].curtainMaker = fstct;
    levelStatus.curtain[0].rank = lvl;
    return;
  } else {
    levelStatus.curtain[0].curtainMaker = fstct;
    levelStatus.curtain[0].rank = fstct.maxRank;
  }
  lvl = (lvl<<8)/fstct.maxRank;
  for ( i=1 ; i<LevelStatus.CURTAIN_MAX ; i++ ) {
    CurtainMaker ct;
    ct = ctType[cttqSelect][ctTypeQue[cttqSelect][0]];
    cttqStatus[cttqSelect] = rollCurtainTypeQue
      (ctTypeQue[cttqSelect], cttqStatus[cttqSelect], cttqSelect+2);
    cttqSelect = (cttqSelect+1)&1;
    lvlPrm = 256 + ct.maxRank*MIXED_CURTAIN_PRM;
    levelStatus.curtainNmb++;
    if ( lvl <= lvlPrm ) {
      int rnk;
      levelStatus.curtain[i].curtainMaker = ct;
      rnk = (lvl-256)/MIXED_CURTAIN_PRM;
      if ( rnk < 1 ) rnk = 1;
      levelStatus.curtain[i].rank = rnk;
      return;
    } else {
      levelStatus.curtain[i].curtainMaker = ct;
      levelStatus.curtain[i].rank = ct.maxRank;
      lvl <<= 8;
      lvl /= lvlPrm;
    }
  }
}

private void resetLevel() {
  CurtainMaker.timer = 0;
  prefData.lvlTime -= 2;
  if ( prefData.lvlTime < LEVEL_TIME_MIN ) {
    prefData.lvlTime = LEVEL_TIME_MIN;
  }
  resetBullets();
  getPrefData();
  gotoNextLevel();
}

void startGame() {
  //gameStatus.status = GAME_IN_PROGRESS;
  mouseX = 80; mouseY = 120;
  xp = 80<<4; yp = 120<<4;
  pxp = xp+1; pyp = yp;
  resetBullets();
  gotoNextLevel();
}

private void addBullets() {
  int i;
  for ( i=0 ; i<levelStatus.curtainNmb ; i++ ) {
    levelStatus.curtain[i].curtainMaker.make(levelStatus.curtain[i].rank);
  }
}

private final int SCREEN_WIDTH_16 = 2560;
private final int SCREEN_HEIGHT_16 = 2560;

private final int BULLET_COLOR = 0xffffff;
private final int BULLET_LINE_COLOR = 0xff4488;

private void moveBullets() {
  Bullet bl;
  int i;
  if ( halfFrameRate ) {

  for ( i=0 ; i<BULLET_MAX ; i++ ) {
    bl = bullet[i];
    if ( bl.point0.mx != BULLET_NOT_EXIST ) {
      if ( bl.vctChk ) {
	bl.prvPoint0.x = bl.point0.x;
	bl.prvPoint0.y = bl.point0.y;
	bl.prvPoint1.x = bl.point1.x;
	bl.prvPoint1.y = bl.point1.y;
      }
      bl.point0.x += bl.point0.mx;
      bl.point0.y += bl.point0.my;
      bl.point1.x += bl.point1.mx;
      bl.point1.y += bl.point1.my;
      if ( (bl.point0.x < 0 || bl.point0.x >= SCREEN_WIDTH_16
	    || bl.point0.y < 0 || bl.point0.y >= SCREEN_HEIGHT_16 ) &&
	   (bl.point1.x < 0 || bl.point1.x >= SCREEN_WIDTH_16
	    || bl.point1.y < 0 || bl.point1.y >= SCREEN_HEIGHT_16 ) ) {
	bl.point0.mx = BULLET_NOT_EXIST;
      } else {
	screen.drawLine((bl.point0.x>>4), (bl.point0.y>>4),
		    (bl.point1.x>>4), (bl.point1.y>>4), BULLET_COLOR);
      }
    }
  }

  } else {

  for ( i=0 ; i<BULLET_MAX ; i++ ) {
    bl = bullet[i];
    if ( bl.point0.mx != BULLET_NOT_EXIST ) {
      if ( bl.vctChk ) {
	bl.prvPoint0.x = bl.point0.x;
	bl.prvPoint0.y = bl.point0.y;
	bl.prvPoint1.x = bl.point1.x;
	bl.prvPoint1.y = bl.point1.y;
      }
      bl.point0.x += bl.point0.mx>>1;
      bl.point0.y += bl.point0.my>>1;
      bl.point1.x += bl.point1.mx>>1;
      bl.point1.y += bl.point1.my>>1;
      if ( (bl.point0.x < 0 || bl.point0.x >= SCREEN_WIDTH_16
	    || bl.point0.y < 0 || bl.point0.y >= SCREEN_HEIGHT_16 ) &&
	   (bl.point1.x < 0 || bl.point1.x >= SCREEN_WIDTH_16
	    || bl.point1.y < 0 || bl.point1.y >= SCREEN_HEIGHT_16 ) ) {
	bl.point0.mx = BULLET_NOT_EXIST;
      } else {
	screen.drawLine((bl.point0.x>>4), (bl.point0.y>>4),
		    (bl.point1.x>>4), (bl.point1.y>>4), BULLET_COLOR);
      }
    }
  }

  }
}

private void hitBullet() {
  prefData.miss++;
  resetLevel();
  showLevel(true);
  screen.setMissTexture(levelStatus.miss);
}

private final int CLS_WIDTH = 10;
private final int PEN_COLOR = 0xffddbb;

public final void movePen() {
  int px, py;
  Boolean pd;
  int i;
  Bullet bl;
  int a1x, a1y, a2x, a2y, b1x, b1y, b2x, b2y;
  int a, b, c, d, e, f, dnm;
  int mk;
  int x, y;

  pxp = xp; pyp = yp;
  if ( mouseX >= 0 && mouseX < Noiz.SCREEN_WIDTH
   && mouseY >=0 && mouseY < Noiz.SCREEN_HEIGHT ) {
    CurtainMaker.xp = xp = (mouseX<<4)+8;
    CurtainMaker.yp = yp = (mouseY<<4)+8;
  }
  screen.drawLine(pxp>>4, pyp>>4, xp>>4, yp>>4, PEN_COLOR);
  if ( xp==pxp && yp==pyp ) {
    pxp = xp+1;
  }

  if ( xp < pxp ) {
    a1x =  xp-CLS_WIDTH; a2x = pxp+CLS_WIDTH;
  } else {
    a1x = pxp-CLS_WIDTH; a2x =  xp+CLS_WIDTH;
  }
  if ( yp < pyp ) {
    a1y =  yp-CLS_WIDTH; a2y = pyp+CLS_WIDTH;
  } else {
    a1y = pyp-CLS_WIDTH; a2y =  yp+CLS_WIDTH;
  }
  for ( i=0 ; i<BULLET_MAX ; i++ ) {
    bl = bullet[i];
    if ( bl.point0.mx != BULLET_NOT_EXIST ) {
      if ( bl.vctChk ) {
	a = bl.point0.y - bl.point1.y;
	b = bl.point1.x - bl.point0.x;
	c = bl.point1.x*bl.point0.y
	  - bl.point1.y*bl.point0.x;
	mk = a*pxp + b*pyp - c;
	if ( mk > 0 ) mk = 1;
	else mk = -1;

	a = bl.prvPoint0.y - bl.prvPoint1.y;
	b = bl.prvPoint1.x - bl.prvPoint0.x;
	c = bl.prvPoint1.x*bl.prvPoint0.y
	  - bl.prvPoint1.y*bl.prvPoint0.x;
	mk *= (a*pxp + b*pyp - c);

	if ( mk < 0 ) {
	  a = bl.point0.y - bl.prvPoint0.y;
	  b = bl.prvPoint0.x - bl.point0.x;
	  c = bl.prvPoint0.x*bl.point0.y
	    - bl.prvPoint0.y*bl.point0.x;
	  mk = a*pxp + b*pyp - c;
	  if ( mk > 0 ) mk = 1;
	  else mk = -1;
	  a = bl.point1.y - bl.prvPoint1.y;
	  b = bl.prvPoint1.x - bl.point1.x;
	  c = bl.prvPoint1.x*bl.point1.y
	    - bl.prvPoint1.y*bl.point1.x;
	  mk *= (a*pxp + b*pyp - c);
	  if ( mk < 0 ) {
	    hitBullet();
	    return;
	  }
	}
      }
      if ( bl.point0.y < bl.point1.y ) {
	b1y = bl.point0.y-CLS_WIDTH; b2y = bl.point1.y+CLS_WIDTH;
      } else {
	b1y = bl.point1.y-CLS_WIDTH; b2y = bl.point0.y+CLS_WIDTH;
      }
      if ( a2y>=b1y && b2y>=a1y ) {
	if ( bl.point0.x < bl.point1.x ) {
	  b1x = bl.point0.x-CLS_WIDTH; b2x = bl.point1.x+CLS_WIDTH;
	} else {
	  b1x = bl.point1.x-CLS_WIDTH; b2x = bl.point0.x+CLS_WIDTH;
	}
	if ( a2x>=b1x && b2x>=a1x ) {
	  a = yp - pyp;
	  b = pxp - xp;
	  c = pxp*yp - pyp*xp;
	  d = bl.point0.y - bl.point1.y;
	  e = bl.point1.x - bl.point0.x;
	  f = bl.point1.x*bl.point0.y
	    - bl.point1.y*bl.point0.x;
	  dnm = b*d - a*e;
	  if ( dnm != 0 ) {
	    x = (b*f - c*e) / dnm;
	    y = (c*d - a*f) / dnm;
            if ( a1x<=x && x<=a2x && a1y<=y && y<=a2y &&
              b1x<=x && x<=b2x && b1y<=y && y<=b2y ) {
		hitBullet();
		return;
            }
	  }
	}
      }
    }
  }
}

  // java lifecycle management

  private boolean halfFrameRate = false;

  public void setHalfFrameRate(boolean f) {
    halfFrameRate = f;
    if ( halfFrameRate ) {
      duration = 100;
    } else {
      duration = 50;
    }
    screen.setHalfFrameRate(f);
  }

  private int mouseX, mouseY;

  public final void setMousePos(int x, int y) {
    mouseX = x>>1; mouseY = y>>1;
  }

  private int duration = 50;

  private Timer timerTrd;
  private Noiz noiz;
  private Screen screen;

  public void init(Noiz noiz, Screen screen) {
    this.noiz = noiz;
    this.screen = screen;
    initGame();
  }

  public void start() {
    startGame();
    timerTrd = new Timer(this);
    timerTrd.activate(duration, false);
  }

  public void restart() {
    if ( timerTrd != null ) {
      timerTrd.deactivate();
    }
  }
  private synchronized void waitFrame() {
    try {
      wait();
    } catch ( InterruptedException e ) {}
  }

  public synchronized final void notifyFrame() {
    notifyAll();
  }

  private int flmCnt = 0;

  private void gameWakeUp() {
    screen.clear();
    flmCnt++;
    if ( halfFrameRate || (flmCnt&1) == 0 ) {
      addBullets();
      CurtainMaker.timer++;
      if ( CurtainMaker.timer >= levelStatus.lvlTime ) {
        gotoNextLevel();
      }
    }
    moveBullets();
    movePen();
    screen.drawLevelMissLetters();
    screen.swap();
  }

  public final void wakeUp() {
    gameWakeUp();
    waitFrame();
  }
}
